<template>
  <div>
    <Multiselect
      v-model="selection"
      style="margin-top: 0.5em;"
      :options="results"
      :optionsLimit="10"
      :allow-empty="false"
      track-by="id"
      label="display_name"
      :resetAfter="false"
      selectLabel=""
      selectedLabel=""
      deselectLabel=""
      :searchable="true"
      :placeholder="placeholder"
      :showNoResults="true"
      :loading="loading"
      :clearOnSelect="false"
      :preserveSearch="true"
      @search-change="search"
      @select="select"
    >
      <span slot="noResult">
        Aucun résultat.
      </span>
      <span slot="noOptions">
        Aucun résultat.
      </span>
    </Multiselect>
  </div>
</template>

<script>
import Multiselect from 'vue-multiselect';

import { mapState, mapMutations, mapActions } from 'vuex';

export default {
  name: 'SearchUsers',

  components: {
    Multiselect
  },

  props: {
    resetAfter: {
      type: Boolean,
      default: true
    },
    placeholder: {
      type: String,
      default: 'Ajouter cette organisation à des groupes d\'organisations'
    }
  },

  data() {
    return {
      selection: null,
      loading: false,
      text: null,
      results: []
    };
  },

  computed: {
    ...mapState('users', [
      'usersList'
    ])
  },

  watch: {
    text: function(newValue) {
      this.loading = true;
      this.SEARCH_USERS_LIST({
        text: newValue
      })
      .then(() => {
        if (newValue) {
          this.results = this.usersList.map(el => {return {
            ...el,
            display_name: el.first_name.concat(' ', el.last_name)
          }});
        } else {
          this.results.splice(0);
        }
        this.loading = false;
      });
    }
  },

  created() {
    this.RESET_CANCELLABLE_SEARCH_REQUEST();
  },

  methods: {
    ...mapMutations(['RESET_CANCELLABLE_SEARCH_REQUEST']),
    ...mapActions('users', [
      'SEARCH_USERS_LIST'
    ]),

    search(text) {
      this.text = text;
    },

    select(e) {
      this.$emit('select', e);
    }
  }
}
</script>

